- Qt 6.8
- Qt 3D
- C++ Classes
- Qt3DExtras (Deprecated)
- QPhongMaterial
- Qt 6.8.2 Reference Documentation

# QPhongMaterial Class

class Qt3DExtras::QPhongMaterial

The QPhongMaterial class provides a default implementation of the phong lighting effect. More...

Header: | `#include <QPhongMaterial>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS 3dextras)` `target_link_libraries(mytarget PRIVATE Qt6::3dextras)`
qmake: | `QT += 3dextras`
Inherits: | Qt3DRender::QMaterial
Status: | Deprecated

This class is deprecated. We strongly advise against using it in new code.

- List of all members, including inherited members

## Properties

- ambient : QColor
- diffuse : QColor
- shininess : float
- specular : QColor

## Public Functions

| QPhongMaterial(Qt3DCore::QNode *parent = nullptr)
virtual | ~QPhongMaterial()
QColor | ambient() const
QColor | diffuse() const
float | shininess() const
QColor | specular() const

## Public Slots

void | setAmbient(const QColor &ambient)
void | setDiffuse(const QColor &diffuse)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(const QColor &diffuse)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)

## Detailed Description

This class is deprecated; use QDiffuseSpecularMaterial instead.

The phong lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components are controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : QColor

Holds the diffuse color.

Access functions:

QColor | diffuse() const
void | setDiffuse(const QColor &diffuse)

Notifier signal:

void | diffuseChanged(const QColor &diffuse)

### shininess : float

Holds the shininess exponent.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

## Member Function Documentation

### `[explicit]` QPhongMaterial::QPhongMaterial(Qt3DCore::QNode *parent = nullptr)

Constructs a new QPhongMaterial instance with parent object parent.

### `[virtual noexcept]` QPhongMaterial::~QPhongMaterial()

Destroys the QPhongMaterial.